/* rm ex	The Sword in the Rock: excalibur.c */
#include "descriptor/descriptor.h"

int main(void)
{
	/* Oggetti */
	ITEM Hilt,Blade;	// Elsa,Lama
	ITEM Gem;
	ITEM Anvil;	// Indudine
	ITEM Stair;		// Scale
	ITEM Square;		// Piazza

	/* Attributi */
	ITEM hilt,blade;	// Elsa,Lama
	ITEM gem;
	ITEM anvil;	// Indudine
	ITEM stair;		// Scale
	ITEM square;		// Piazza

	ITEM Scene;

	/****** Setting ******/
	set_background(0.5,0.5,0.6,TRUE);
	set_ambient_light(1,1,1,0.6);
	create_point_light(35,4,7,1,1,1,1,0,"Sole");

	/****** Attribute Creation ******/
	// Elsa
	hilt=create_attribute("hilt");
	set_color(hilt,0.9,0.9,0.2,0.6,0.8);	
	set_reflectivity(hilt,0.2,2);
	Hilt=create_list(read_nurbs("Guardia.db"),"Hilt");
	Hilt=insert_in_list(Hilt,read_nurbs("Guardia_Sx.db"));
	Hilt=insert_in_list(Hilt,read_nurbs("Guardia_Dx.db"));
	Hilt=insert_in_list(Hilt,read_nurbs("Pomo_1.db"));
	Hilt=insert_in_list(Hilt,read_nurbs("Impugnatura.db"));
	set_attribute(Hilt,hilt);
	
	set_scale(Hilt,1.0/10,1.0/10,1.0/10);		
	set_y_rotate(Hilt,90,1);
	set_projection_texture(Hilt,hilt,"textures/gold.hr",1,TRUE,0.6,0.8);
	set_y_rotate(Hilt,-90,1);
	set_scale(Hilt,10,10,10);

	// Gemma
	gem=create_attribute("gem");
	set_color(gem,1,0,0,1,1);
	set_reflectivity(gem,0.2,2);
	Gem=read_nurbs("Pomo_2.db");
	set_attribute(Gem,gem);
	
	// Lama
	blade=create_attribute("blade");
	set_reflectivity(blade,0.2,2);
	Blade=read_nurbs("Lama.db");
	set_attribute(Blade,blade);

	set_scale(Blade,1.0/10,1.0/10,1.0/10);		
	set_y_rotate(Blade,90,1);
	set_projection_texture(Blade,blade,"textures/metal.hr",1,TRUE,0.6,0.8);
	set_y_rotate(Blade,-90,1);
	set_scale(Blade,10,10,10);		

	
	
	// Incudine
	anvil=create_attribute("anvil");
	set_reflectivity(anvil,0,2);
	Anvil=read_nurbs("Incudine.db");
	set_attribute(Anvil,anvil);
	set_projection_texture(Anvil,anvil,"textures/rose_marble.hr",2,TRUE,0.6,0.8);
	
	// Scale
	stair=create_attribute("stair");
	set_reflectivity(stair,0.1,2);
	Stair=read_nurbs("Scala.db");
	set_attribute(Stair,stair);
	set_projection_texture(Stair,stair,"textures/stone.hr",2,TRUE,0.6,0.8);

	// Piazza
	square=create_attribute("square");
	set_reflectivity(square,0,2);
	Square=read_nurbs("Piazza.db");
	set_attribute(Square,square);
	set_projection_texture(Square,square,"textures/grass.hr",2,TRUE,1,1);

	// Scena
	Scene=create_list(Hilt,"Scene");
	Scene=insert_in_list(Scene,Gem);
	Scene=insert_in_list(Scene,Blade);
	Scene=insert_in_list(Scene,Anvil);	
	Scene=insert_in_list(Scene,Stair);
	Scene=insert_in_list(Scene,Square);
	
	save_scene("excalibur.md","excalibur",Scene);
	return(0);
}
